#!/usr/bin/env python3
# -*- coding: utf-8 -*-
'包含两个函数：音频转文字/文字转音频'

# baidu_ai.py 文件内容
import os
from aip import AipSpeech


#语音转字符串函数，输入语音文件文件名，反馈一个识别内容（打印内容自选）
def audio_to_text(pcm_file,APPID, API_KEY, SECRET_KEY):
    client = AipSpeech (APPID, API_KEY, SECRET_KEY)  # 三个内容为百度API
    #打开语音文件并读取,读取信息存在file_context
    with open(pcm_file,'rb') as fp:
        file_context = fp.read()
    #向百度云发出请求，百度云反馈字典格式信息（1536、1537可修改，变化不大）
    res = client.asr (file_context, 'pcm', 16000, {'dev_pid': 1536, })
    try:
        res_str = res.get ("result") [0]
    except:
        print ('语音转文字失败，请注意语言清晰度（大部分错误是清晰度问题，具体请查看《https://cloud.baidu.com/doc/SPEECH/s/sk38lxie0》')
        print ('错误信息：',res)  # 打印所有反馈信息，主要用于检查有无错误（包含错误码等等）
        #print('终止程序')
        #os._exit(0)
        pass

    print('语音转文字成功：',res_str)#只打印关键的语音文本信息
    return res_str

#字符串转语音函数，输入字符串文本，生成并反馈一个后缀为MP3的文件名
def text_to_audio(res_str,APPID, API_KEY, SECRET_KEY):
    client = AipSpeech (APPID, API_KEY, SECRET_KEY)  # 三个内容为百度API
    synth_file = "synth.mp3"#MP3文件名，起一个保存作用(作用不大,无需更改，不明白一定不能改后缀)
     # synthesis参数: 文本,语言zh(中文),1为pc端,语音{"vol":音量,
     #"spd":语速,"pit":语调,"per":声道(0:女,1:男,2:逍遥音,4:小萝莉)}
    try:
        os.close(synth_file)
        os.remove(synth_file)#先删除一下文件，以防重名
    except:
        pass                  #如果文件不存在直接跳过
    synth_context = client.synthesis(res_str, "zh", 1, {
        "vol": 5,
        "spd": 5,
        "pit": 3,
        "per": 0
    })
    '''with open(synth_file, "wb") as f:
        f.write(synth_context)'''
    f=open(synth_file, "wb")
    f.write(synth_context)
    f.close()
    print("文字转语音成功，文件名：",synth_file)
    return synth_file

if __name__=='__main__':
    APPID = "your_APPID"
    API_KEY = "your_API_KEY"
    SECRET_KEY = "your_SECRET_KEY"
    txt=audio_to_text('1.wav',APPID, API_KEY, SECRET_KEY)
    text_to_audio(txt,APPID, API_KEY, SECRET_KEY)
